  MEMBER()

  MAP
  END

JSBrowseList     QUEUE,TYPE
Browse             &BrowseClass
InsertControl      Unsigned
DisableListControl Byte
                 END

  INCLUDE('ABWINDOW.INC'),ONCE
  INCLUDE('KEYCODES.CLW'),ONCE
  INCLUDE('ABBROWSE.INC'),ONCE
  INCLUDE('JSBROWSE.INC'),ONCE


JSBrowseClass.AddItem        PROCEDURE(BrowseClass BC,BYTE DisableListControl=1)
  CODE
    If SELF.Browses &= NULL
      SELF.Browses &= NEW JSBrowseList  !Since INIT() isn't virtual, wasn't sure what would happen if I tried this in INIT(). Don't want to find out now<g>
    end
    SELF.Browses.Browse            &= BC
    SELF.Browses.InsertControl      = 0
    SELF.Browses.DisableListControl = DisableListControl !If there are no parent records, the child list control automatically is disabled
    ADD(SELF.Browses)

JSBrowseClass.Ask PROCEDURE(BYTE Req)
Response BYTE
  CODE
  Response = PARENT.Ask(Req)
  If Response = RequestCompleted
    IF ~SELF.Sort.Locator &= NULL
      SELF.Sort.Locator.Set
    END
  end
  Return Response

JSBrowseClass.Kill           PROCEDURE
  CODE  
    If NOT SELF.Browses &= NULL
      DISPOSE(SELF.Browses)
    END
    PARENT.Kill

JSBrowseClass.UpdateBuffer   PROCEDURE
Ndx          Long
  CODE

  If Self.HaveChildren()
    SELF.ListQueue.Fetch(Choice(SELF.ILC.GetControl()))
    If SELF.SaveViewPosition <> SELF.ListQueue.GetViewPosition() 
      SELF.SaveViewPosition = SELF.ListQueue.GetViewPosition()
      Loop Ndx = 1 to Records(SELF.Browses)
        Get(SELF.Browses,Ndx)
        SELF.Browses.Browse.ListQueue.Free
        SELF.Browses.Browse.Reset
      end
    end
  end
  PARENT.UpdateBuffer

JSBrowseClass.UpdateWindow        PROCEDURE
Ndx          Long
  CODE

  PARENT.UpdateWindow
  If Self.HaveChildren()
    Loop Ndx = 1 to Records(SELF.Browses)
      Get(SELF.Browses,Ndx)
      SELF.Browses.InsertControl = Choose(~SELF.Browses.InsertControl,SELF.Browses.Browse.InsertControl,SELF.Browses.InsertControl)
      PUT(Self.Browses)
      If SELF.Browses.InsertControl
        If ~SELF.Records()
           If SELF.Browses.DisableListControl
             DISABLE(SELF.Browses.Browse.ILC.GetControl())
           end
           DISABLE(SELF.Browses.InsertControl)
           SELF.Browses.Browse.InsertControl=0
        else
           If SELF.Browses.DisableListControl
             ENABLE(SELF.Browses.Browse.ILC.GetControl())
           end
           ENABLE(SELF.Browses.InsertControl)
           SELF.Browses.Browse.InsertControl=SELF.Browses.InsertControl
        end
      end
    end
  end

JSBrowseClass.HaveChildren        PROCEDURE
  CODE

  Return Choose(NOT SELF.Browses &= NULL)


